#!/usr/local/bin/python

import sys
import os
import milter

# This is the name of the unix socket used by sendmail to communicate.
# It *must* match the X line in sendmail.cf (minus the "local:" part)
# or you get no talkies.
socketname = "/etc/mail/pythonsock"

def connectcallback(hostname,family,hostaddr):
   print "connectcallback: connect from %s" % hostname
   filename = "SomeGeneratedFilename"
   milter.setpriv(filename)
   return milter.CONTINUE

def helocallback(hostname):
   print "helocallback: helo from %s" % hostname
   filename = milter.getpriv()
   print "helocallback: saved filename is %s" % filename
   return milter.CONTINUE

def envfromcallback(*str):
   for i in range(len(str)):
      print "envfromcallback: %s" % str[i]
   filename = milter.getpriv()
   print "envfromcallback: saved filename is %s" % filename
   return milter.CONTINUE

def envrcptcallback(*str):
   for i in range(len(str)):
      print "envrcptcallback: %s" % str[i]
   filename = milter.getpriv()
   print "envrcptcallback: saved filename is %s" % filename
   return milter.CONTINUE

def headercallback(field, value):
   print "headercallback: field = %s" % field
   print "headercallback: value = %s" % value
   filename = milter.getpriv()
   print "headercallback: saved filename is %s" % filename
   return milter.CONTINUE

def eohcallback():
   print "eohcallback"
   filename = milter.getpriv()
   print "eohcallback: saved filename is %s" % filename
   return milter.CONTINUE

def bodycallback(chunk):
   print "bodycallback: chunk = \"%s\"..." % chunk[0:40]
   body.append(chunk)
   filename = milter.getpriv()
   print "bodycallback: saved filename is %s" % filename
   return milter.CONTINUE

def eomcallback():
   print "eomcallback"
   filename = milter.getpriv()
   print "eomcallback: saved filename is %s" % filename
   return milter.CONTINUE

def abortcallback():
   print "abortcallback"
   filename = milter.getpriv()
   print "abortcallback: saved filename is %s" % filename
   return milter.CONTINUE

def closecallback():
   print "closecallback"
   filename = milter.getpriv()
   print "closecallback: saved filename is %s" % filename
   return milter.CONTINUE

# This bit is here on the assumption that you will be starting this filter
# before sendmail.  If sendmail is not running and the socket already exists,
# libmilter will throw a warning.  If sendmail is running, this is still
# safe if there are no messages currently being processed.  It's safer to
# shutdown sendmail, kill the filter process, restart the filter, and then
# restart sendmail.
print "Removing %s" % socketname
try:
  os.unlink(socketname)
except:
  pass

# The name *must* match the X line in sendmail.cf (supposedly)
milter.set_name("pythonfilter")
# The default flags set include everything
# milter.set_flags(milter.ADDHDRS)
milter.set_connect_callback(connectcallback)
milter.set_helo_callback(helocallback)
milter.set_envfrom_callback(envfromcallback)
milter.set_envrcpt_callback(envrcptcallback)
milter.set_header_callback(headercallback)
milter.set_eoh_callback(eohcallback)
milter.set_body_callback(bodycallback)
milter.set_eom_callback(eomcallback)
milter.set_abort_callback(abortcallback)
milter.set_close_callback(closecallback)

milter.setconn(socketname)
milter.settimeout(10)
milter.setdbg(3)
milter.register()
milter.main()
