#!/usr/local/bin/python

# This is a fiter that replaces virus-laden messages with a canned message,
# saving the original content to a tempfile.

import sys
import os
import sre
import tempfile
import milter

hostname = (os.uname())[1]

# This is the name of the unix socket used by sendmail to communicate.
# It *must* match the X line in sendmail.cf (minus the "local:" part)
# or you get no talkies.
socketname = "/etc/mail/pythonsock"

# This is a tuple of recipients to add upon detection of a virus
#NotifyRecipients = ("root",)
NotifyRecipients = ()

# This is the header added to all messages.  It's probably a good idea
# to use "X-" at the beginning of the header.
FilterHeader = "X-VirusCheck"

# This is the value of the header used if a virus is detected
FilterValueDirty = "dirty"

# This is the value of the header used if a virus is not detected
FilterValueClean = "clean"

# This is the message that will be sent.  Put anything you want in here.
# Strings subbed in (in order) are:
# hostname, save-filename
MessageTemplate = """

This is a message from the Sendmail Virus Filter.  I have detected
what I believe to be a virus in a message that was addressed to you.
The sender of the message was (entire next line):
SG
I have saved the entire message in %s:%s.
Please contact your administrator for help in salvaging any useful
information from the message text.

Thank you,
SVF
"""

class SaveInfo:
   def __init__(self):
      self.filename = None
      self.fd = None
      self.flag = 0
      self.patterns = (".*virus.*",)
   def makefile(self):
      self.filename = tempfile.mktemp(".virusfilter")
      print "created filename is %s" % self.filename
      try:
         self.fd = open(self.filename, 'w')
      except:
         print "Hey! Cannot open %s" % self.filename

def connectcallback(hostname,family,hostaddr):
   print "connectcallback"
   p = SaveInfo()
   milter.setpriv(p)
   return milter.CONTINUE

def helocallback(hostname):
   print "helocallback"
   return milter.CONTINUE

def envfromcallback(*str):
   print "envfromcallback"
#   for i in range(len(str)):
#      print "envfromcallback: %s" % str[i]
   return milter.CONTINUE

def envrcptcallback(*str):
   print "envrcptcallback"
#   for i in range(len(str)):
#      print "envrcptcallback: %s" % str[i]
   return milter.CONTINUE

def headercallback(field, value):
   print "headercallback"
   return milter.CONTINUE

def eohcallback():
   print "eohcallback"
   p = milter.getpriv()
   p.makefile()
   return milter.CONTINUE

def bodycallback(chunk):
   print "bodycallback"
   p = milter.getpriv()
   p.fd.write(chunk)
   for n in range(len(p.patterns)):
      print "pattern %d is %s" % (n, p.patterns[n])
      result = sre.search(p.patterns[n], chunk)
      if (result is not None):
         p.flag = 1
   return milter.CONTINUE

def eomcallback():
   print "eomcallback"
   p = milter.getpriv()
   p.fd.close()
   if (p.flag):
      print "eomcallback: it's got a virus!"
      s = MessageTemplate % (hostname, p.filename)
      milter.replacebody(s)
      milter.addheader(FilterHeader, FilterValueDirty)
      for n in range(len(NotifyRecipients)):
         milter.addrcpt(NotifyRecipients[n])
   else:
      print "eomcallback: no virus here"
      milter.addheader(FilterHeader, FilterValueClean)
      os.unlink(p.filename)
   del p
   return milter.CONTINUE

def abortcallback():
   print "abortcallback"
   try:
      p = milter.getpriv()
      if (p.filename != None):
         try:
            p.fd.close()
         except:
            pass
      os.unlink(p.filename)
      del p
   except:
      pass
   return milter.CONTINUE

def closecallback():
   print "closecallback"
   return milter.CONTINUE

# This bit is here on the assumption that you will be starting this filter
# before sendmail.  If sendmail is not running and the socket already exists,
# libmilter will throw a warning.  If sendmail is running, this is still
# safe if there are no messages currently being processed.  It's safer to
# shutdown sendmail, kill the filter process, restart the filter, and then
# restart sendmail.  For testing, it's safe to leave sendmail running and to
# stop/edit/start this filter.
print "Removing %s" % socketname
try:
  os.unlink(socketname)
except:
  pass

# The name *must* match the X line in sendmail.cf (supposedly)
milter.set_name("pythonfilter")
# The default flags set include everything
# milter.set_flags(milter.ADDHDRS)
milter.set_connect_callback(connectcallback)
milter.set_helo_callback(helocallback)
milter.set_envfrom_callback(envfromcallback)
milter.set_envrcpt_callback(envrcptcallback)
milter.set_header_callback(headercallback)
milter.set_eoh_callback(eohcallback)
milter.set_body_callback(bodycallback)
milter.set_eom_callback(eomcallback)
milter.set_abort_callback(abortcallback)
milter.set_close_callback(closecallback)

# setconn *must* be called with the pathname of the unix socket
milter.setconn(socketname)
# Avoid timeouts
milter.settimeout(10)
# setdbg doesn't appear to do that much
#milter.setdbg(3)
milter.register()

# This is actually kind of silly, since a control-C also
# causes the underlying C smfi_main to return FAILURE.  FIXME
milter.main()

# This causes a Bus Error ... does stop have to be called from
# a callback?  Dox unclear.
#milter.stop()
sys.exit(0)
